• Najnowsze pytania
  • Bez odpowiedzi
  • Zadaj pytanie
  • Kategorie
  • Tagi
  • Zdobyte punkty
  • Ekipa ninja
  • IRC
  • FAQ
  • Regulamin
  • Książki warte uwagi

question-closed Złapanie error'a axiosem

+1 głos
36 wizyt
pytanie zadane 11 lipca 2020 w JavaScript przez Greeenone Pasjonat (16,020 p.)
zamknięte 11 lipca 2020 przez Greeenone

Hej,

Mam pewien problem ze złapanie errora przy zapytaniu. Przed załadowanie każdej strony, jest wysyłany token do serwera. Jeśli ten się zgadza, serwer zwraca OK, 200. Jeśli token wygasł lub nie ma go w bazie, serwer zwraca kod

401

{"message":"Unauthenticated."}

I teraz nie wiem jak to wyłapać i zmusić użytkownika do wylogowania się po stronie frontu

To jest gotowy kod sprawdzający czy token jest poprawny:

  [VERIFY_AUTH](context) {
    if (JwtService.getToken()) {
      ApiService.setHeader();
      ApiService.get("/sanctum/verify")
        .then(({ data }) => {
          context.commit(SET_AUTH, data);
        })
        .catch(({ response }) => {
          console.log('Wyloguj')
        });
    } else {
      context.commit(PURGE_AUTH);
    }
  },

I teraz sprawa wygląda następująco:

response zwraca "undefine"

Przerobiłem kod następująco:

  [VERIFY_AUTH](context) {
    if (JwtService.getToken()) {
      ApiService.setHeader();
      ApiService.get("/sanctum/verify")
        .then(({ data }) => {
          context.commit(SET_AUTH, data);
        })
        .catch(() => {
          alert('Wylogowuje');
          context.commit(PURGE_AUTH);
        });
    } else {
      context.commit(PURGE_AUTH);
    }
  },

Gdy token się nie zgadza, pojawia się alert "Wylogowuje" ale już purge Auth się nie wykonuje. Na dodatek, konsola zwraca następujący error:

Uncaught (in promise) Error: Request failed with status code 401
    createError createError.js:16
    settle settle.js:17
    handleLoad xhr.js:61

A tutaj jeszcze kod Api GET:

  get(resource, slug = "") {
    return Vue.axios.get(`${resource}/${slug}`).catch(error => {
      // console.log(error);
      throw new Error(`[KT] ApiService ${error}`);
    });
  },

Jest to prawdopodobnie jakiś problem w przekazywaniu Error'a

komentarz zamknięcia: Rozwiązane
komentarz 11 lipca 2020 przez ScriptyChris Mędrzec (168,460 p.)

Gdy token się nie zgadza, pojawia się alert "Wylogowuje" ale już purge Auth się nie wykonuje. Na dodatek, konsola zwraca następujący error

 Po czym poznajesz, że purge auth się nie wykonuje? Którego Promisa dotyczy ten error?

W niepoprawnym przekazaniu errora chodzi o tą linijkę, gdzie response jest undefined?

.catch(({ response }) => {

Czy metoda context.commit jest synchroniczna?

komentarz 11 lipca 2020 przez Greeenone Pasjonat (16,020 p.)
Dzięki za odpowiedź. Popełniłem gafę. Użytkownik zostawał wylogowany ale link się nie zmieniał. Error pochodził z innego requesta który nie powinien się wykonać

Podobne pytania

0 głosów
0 odpowiedzi 104 wizyt
0 głosów
2 odpowiedzi 153 wizyt
0 głosów
1 odpowiedź 72 wizyt

85,802 zapytań

134,588 odpowiedzi

298,790 komentarzy

56,697 pasjonatów

Advent of Code 2021

Top 15 użytkowników

  1. 494p. - rucin93
  2. 482p. - CC PL
  3. 463p. - nidomika
  4. 385p. - Whistleroosh
  5. 379p. - ScriptyChris
  6. 372p. - adrian17
  7. 340p. - TheLukaszNs
  8. 339p. - WhiskeyTaster
  9. 321p. - Argeento
  10. 318p. - Dagohar
  11. 287p. - Anonim 1794483
  12. 281p. - Klaudia
  13. 278p. - B4mbus
  14. 269p. - b0mbix
  15. 246p. - tokox
Szczegóły i pełne wyniki

Motyw:

Akcja Pajacyk

Pajacyk od wielu lat dożywia dzieci. Pomóż klikając w zielony brzuszek na stronie. Dziękujemy! ♡

Oto dwie polecane książki warte uwagi. Pełną listę znajdziesz tutaj.

...